704. Binary Search

Given an array of integers nums which is sorted in ascending order, and an integer target, write a function to search target in nums. If target exists, then return its index. Otherwise, return -1.

You must write an algorithm with O(log n) runtime complexity.

Example 1:

复制代码
Input: nums = [-1,0,3,5,9,12], target = 9
Output: 4
Explanation: 9 exists in nums and its index is 4

Example 2:

复制代码
Input: nums = [-1,0,3,5,9,12], target = 2
Output: -1
Explanation: 2 does not exist in nums so return -1

Constraints:

  • 1 <= nums.length <= 104
  • -104 < nums[i], target < 104
  • All the integers in nums are unique.
  • nums is sorted in ascending order.

1.左闭右开写法:

注意事项:区间内定义是否合法,主要表现为以下三个地方:

(1)int right=nums.size();

因为右边的是开,所以right的值应该比最大的下标+1

(2)while(left<right)

当left=right的时候,区间是不合法的,所以left!=right

(3)if(numsmiddle>target){

right=middle;

}

在这里,right=middle, 因为右边的是开,right的值是取不到的,所以可以等于middle。

还有一点就是后面else if的判断句,left=middle+1,如果写成left=middle的话,会超出时间限制。

复制代码
class Solution {
public:
    int search(vector<int>& nums, int target) {
        int left=0;
        int right=nums.size();
        while(left<right){
            int middle=(left+right)/2;
            if(nums[middle]>target){
                right=middle;
            }
            else if(nums[middle]<target){
                left=middle+1;
            }
            else{
                return middle;
            }
        }
        return -1;
    }
};

2.左闭右闭写法:

注意事项:依旧是区间的合法性,具体体现为以下四点:

(1)int right=nums.size()-1;

因为右边的是闭,所以right的值应该=最大的下标

(2)while(left<=right)

当left=right的时候,区间是合法的,所以left可以=right,不要漏了这个条件

(3)if(numsmiddle>target){

right=middle-1;

}

在这里,right=middle-1, 因为右边的是闭,right的值是取得到的,在if条件判断中已经判断了middle下标的值>target,如果不是middle-1的话,在边界条件上就会出问题了,因为右边是闭。

(4)else if(numsmiddle<target){

left=middle+1;

}

left=middle+1,理由同(3)

复制代码
class Solution {
public:
    int search(vector<int>& nums, int target) {
        int left=0;
        int right=nums.size()-1;
        while(left<=right){
            int middle=(left+right)/2;
            if(nums[middle]>target){
                right=middle-1;
            }
            else if(nums[middle]<target){
                left=middle+1;
            }
            else{
                return middle;
            }
        }
        return -1;
    }
};

总之,两种写法都可以,最重要的是看区间的边界是否合法。

相关推荐
yi0114 小时前
DAY17: LeetCode 139|单词拆分:从“把单词删掉”到用 DP 记录合法切口
人工智能·笔记·python·算法·leetcode·动态规划
陈希瑞4 小时前
LongCat-2.5-Preview 的web逆向能力实测
人工智能·算法·wasm
tangguofeng6 小时前
基于分治策略的循环赛日程表问题的思路讲解
算法
hnjzsyjyj6 小时前
洛谷 P1339:[USACO09OCT] Heat Wave G ← Bellman-Ford 算法
数据结构·bellman-ford 算法
起个名字费劲死了6 小时前
VisionMaster集成深度学习算法(基础狗)
人工智能·深度学习·算法
lengxuenong6 小时前
枚举例题分析
c++·算法·青少年编程
Navigator_Z6 小时前
LeetCode //C - 1269. Number of Ways to Stay in the Same Place After Some Steps
c语言·算法·leetcode
2601_965742226 小时前
短视频脚本创作方法分享:本地生活类账号的起步思路
大数据·人工智能·算法·ai·新媒体运营·生活
55873生态系统手记6 小时前
读完 55873 资产钱包的技术栈,我重新理解了 "合规钱包" 应该长什么样
算法·架构
旋生万物7 小时前
素数螺旋映射 $z_n=n^{1+i}$ 的角分布统计检验与零模型对比
大数据·前端·人工智能·算法·云原生·螺旋生成论·螺旋相位